#ifndef _THTTP_H
#define _THTTP_H

#include <time.h>
#include "HappyHTTP/happyhttp.h"

using namespace std;

class THttp
{
private:
	happyhttp::Connection m_pLink;

public:
	int	m_iError;
	int	m_iHttpCode;
	char*	m_szHttpReason;
	int	m_iResponseSize;
	char*	m_szResponse;
	time_t	m_tTimeout;
	char	m_szTarget[64];

//	THttp() { };
//	~THttp() { delete &m_pLink; free(m_szResponse); };
	void Request(const char* target, const char* host, const char* method, const char* url, int timeout);
	void Request(const char* target, const char* host, const char* method, const char* url, const char* headers[], const unsigned char* body, int bodysize, int timeout);
	void CancelHttp();
	bool Poll();
	bool Active();
};

#endif
