#include "string.h"
#include "sdk/amxxmodule.h"

#include "include/linkedlist.h"
#include "include/thttp.h"

using namespace std;

linkedListType<THttp> g_THttpList;
int FF_THttpResponse;

cell AMX_NATIVE_CALL NATIVE_THttpRequest(AMX* amx,cell* params)
{
	THttp * temp;
	temp = new THttp();
	if(temp)
	{
		int len;

		char *key, *url, *method, *path, *buf;

		key = MF_GetAmxString(amx, params[1], 0, &len);
		url = MF_GetAmxString(amx, params[2], 1, &len);
		method = MF_GetAmxString(amx, params[3], 2, &len);
		path = MF_GetAmxString(amx, params[4], 3, &len);

		g_THttpList.appendItem(*temp);
		temp->Request(key, url, method, path, 1);
	}
}

void THttp_Response(THttp * pThread)
{
	if(FF_THttpResponse)
	{
		MF_ExecuteForward(FF_THttpResponse, pThread->m_szTarget, pThread->m_szResponse, pThread->m_iHttpCode, pThread->m_szHttpReason);
	}
}

void StartFrame()
{
	if(g_THttpList.countItems())
	{
		THttp * pThread = g_THttpList.firstItem();

		do
		{
			if(pThread)
			{
				if(pThread->Active())
				{
					pThread->Poll();

					if(pThread->m_iError)
						THttp_Response(pThread);

					pThread = g_THttpList.nextItem();
				}
				else
				{
					pThread = g_THttpList.deleteItem();
				}
			}
		}
		while(pThread);
	}

	RETURN_META(MRES_IGNORED);
}

AMX_NATIVE_INFO natives_Exports[] = {
	  /////////////////// <--- 19 chars max in current small version
	{"thttp_request", NATIVE_THttpRequest},
	{NULL,					NULL}
};

void OnAmxxAttach()
{
	MF_AddNatives(natives_Exports);
	FF_THttpResponse = 0;
}

void OnPluginsLoaded()
{
	FF_THttpResponse = MF_RegisterForward("thttp_response", ET_STOP, FP_STRING, FP_STRING, FP_CELL, FP_STRING, FP_DONE);
}
